/* Name: HelloRobotWorld
 Description: A simple program that illustrates the 
features of BrickOS. The program will: 
 1. Display "Hello World" on the LCS 
 2. Roll foward and then back 
 3. Wait until the either Sensor 1 or 
 Sensor 2 is "touched" 
*/ 
// Include files containing the BrickOS library functions
#include<conio.h> 
#include<dmotor.h> 
#include<dsensor.h> 
#include<unistd.h> 
using namespace std; 
// function prototypes
void hello(); 
void world(); 
void roll(); 
int main() { 
 hello(); // Display "Hello"
 sleep(5); // Pause for 5 seconds
 world(); // Display "World" 
 sleep(5); // Pause for 5 seconds
 roll(); // Roll forward and backwards 
 // Display "HUH" until such time as either sensor 1 
 // or sensor 2 is activated. Display "OUCH" whenever 
 // sensor 2 is activated. Display "BYE" and end the 
 // program when sensor 1 is activated.
while (1) { 
if (TOUCH_2) 
 cputs("OUCH "); 
else if (TOUCH_1) { 
 cputs("BYE "); 
break; 
 } else cputs("Huh "); 
 } // end while
return 0; 
} 

// function hello displays "HELLO" on the LCD
void hello() { 
 cputs("HELLO"); 
} 
// function world displays "WORLD" on the LCD 
void world() { 
 cputs("WORLD"); 
} 
// function roll instructs the robot to roll forward 
// and then to reverse 
void roll() { 
 motor_a_dir(fwd); 
 motor_a_speed(200); 
 motor_c_dir(fwd); 
 motor_c_speed(200); 
 sleep(5); 
 motor_a_dir(rev); 
 motor_a_speed(200); 
 motor_c_dir(rev); 
 motor_c_speed(200); 
 sleep(5); 
 motor_a_dir(off); 
 motor_c_dir(off); 
} 